﻿/* ParameterDictionary.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;

namespace zaaReloaded2.Dictionaries
{
    /// <summary>
    /// Dictionary that is used to convert Lauris parameter names to
    /// canonical parameter names, and to assign categories and determine
    /// which parameters always require the output of reference intervals.
    /// </summary>
    class ParameterDictionary : DictionaryBase
    {
        protected override System.IO.Stream GetDefaultStream()
        {
            return Assembly.GetExecutingAssembly().GetManifestResourceStream("");
        }
    }
}
